--[[
	##AddOn	  : CooldownIcons R(evamped)
	##Subfile : CooldownIconsR_Timer.lua
	##Author  : Hati-EK		
--]]

local LCI = LibStub("LibCooldownIcons")
local CIR = CooldownIconsR
local floor = math.floor
local tinsert, tremove = tinsert, tremove
local tonumber, _G, pairs, unpack, tconcat, wipe, format = tonumber, _G, pairs, unpack, table.concat, wipe, string.format
local GetTime = _G.GetTime
local gcd = CIR.gcd


--[[
-another idea-
Registering SpellCooldowns etc.
if called - scan Icons-table with watch for cooldowns
if something is on Cooldown, if there isn't a CooldownHandler yet - create init one
each Handler carry 5 'cooldowns', so if CooldownHandler[#CooldownHandler].carry >5 -> create a new one
and so on - on talentswap CooldownHandler is reseted
]]
CIR.OnCooldown = { }

function CIR:SPELL_UPDATE_COOLDOWN()
	if not CIR.OnCooldown then
		CIR.OnCooldown={}
	end
	for iN,iT in pairs(self.icons) do
		if iT.watch and iT.enabled then
			local start,duration = LCI:GetCooldownByCmd(iT.cmd,self:FlagToEquip(iT.watch))
			if start and duration then
				local now = GetTime()
				local iconInTable,num = LCI:inTable(iN,self.OnCooldown)
				if not iT.tf then
					iT.tf = CIR.db.char.icondb[iN].options.timeFormat or 1
				end
				if not iT.dt then --get dt if not avaible
					iT.dt = CIR.db.char.icondb[iN].options.display or 1
				end
				if now<=(start+(duration-gcd)) then
					if not iconInTable then
						tinsert(self.OnCooldown,iN)
						if iT.dt==3 then
							if CIR.fade_in_support then
								local cAlpha = iT:GetAlpha()
								LCI:UIFrameFadeIn(iT,1,(cAlpha),0,'out')
							else
								iT:SetAlpha(0)
							end
						else
							iT:SetAlpha(1)
						end
						--grayscaling
						if CIR.db.char.icondb[iN].options.grayscaling then
							iT.tex:SetDesaturated(1)
						end
					end			
				elseif now>(start+(duration)) then
					if iconInTable then
						tremove(self.OnCooldown,num)
						if iT.dt==3 then
							if CIR.fade_in_support then
								local cAlpha = iT:GetAlpha()
								LCI:UIFrameFadeIn(iT,1,(cAlpha),1,'in')
							else
								iT:SetAlpha(1)
							end
						elseif iT.dt==2 then
							iT:SetAlpha(0)
						else
							iT:SetAlpha(1)
						end
						--grayscaling_off
						iT.tex:SetDesaturated(0)
						iT.time:SetText("")
					end
				end
			end
		end
	end
end

local function calctime(start,duration,tF,icon)
	local racc=CIR.db.char.accuracy or 0
	local accuracy=10^racc
	local time=(duration-(GetTime()-start))
	if tF==1 then
		local ts=format("%."..racc.."f",time)
		return ts
	elseif tF==2 then
		local m = floor(time/60)
		local s = floor(time-(m*60))
		if m>=0 and s>9 then return(m..":"..s)
		elseif s>=0 then return(m..":0"..s)
		end
	elseif tF==3 then
		local m = floor(time/60)
		local s = time-(time*m)
		if m>0 then return(m.."m")
		else
			s=format("%."..racc.."f",s)
			return(s)
		end
	elseif tF==4 then
		if time<=(CIR.db.char.icondb[icon].options.tmin_tf4 or 6) then
			local ts=format("%."..racc.."f",time)
			return(ts)
		else
			local ts=format("%.0f",time)
			return(ts)
		end
	end
end

local cdc = CreateFrame("Frame","CooldownIconsR_Updater",CIR.Anchor)
cdc:SetScript('OnUpdate',function(self,elapsed)
	if not self.lastUpdate  then
		self.lastUpdate=0
	end
	self.lastUpdate = self.lastUpdate+elapsed
	while (self.lastUpdate > CIR.updateFrequency) do
		local toRem
		toRem = {}
		for num,icon in ipairs(CIR.OnCooldown) do
			local iT = CIR.icons[icon]
			if not iT.tf then
				iT.tf = CIR.db.char.icondb[icon].options.timeFormat or 1
			end
			if not iT.dt then --get dt if not avaible
				iT.dt = CIR.db.char.icondb[icon].options.display or 1
			end
			local start,duration = LCI:GetCooldownByCmd(iT.cmd,CIR:FlagToEquip(iT.watch))
			if GetTime()<=(start+(duration)) then
				if iT.dt==3 then
					if CIR.fade_in_support then
						local cAlpha = iT:GetAlpha()
						LCI:UIFrameFadeIn(iT,1,(cAlpha),0,'out')
					else
						iT:SetAlpha(0)
					end
				else
					iT:SetAlpha(1)
				end	
				
				local text=calctime(start,duration,iT.tf,icon)
				--grayscaling
				if CIR.db.char.icondb[icon].options.grayscaling then
					iT.tex:SetDesaturated(1)
				end
				iT.time:SetText(text)
			elseif GetTime()>(start+(duration)) then
				if iT.dt==3 then
					if CIR.fade_in_support then
						local cAlpha = iT:GetAlpha()
						LCI:UIFrameFadeIn(iT,1,(cAlpha),1,'in')
					else
						iT:SetAlpha(1)
					end
				elseif iT.dt==2 then
					iT:SetAlpha(0)
				else
					iT:SetAlpha(1)
				end
				--grayscaling_off
				iT.tex:SetDesaturated(0)
				iT.time:SetText("")
				tinsert(toRem,num)
			end
		end
		while #toRem>0 do
			tremove(CIR.OnCooldown,toRem[1])
			tremove(toRem,1)
			if #toRem==0 then
				CIR:SPELL_UPDATE_COOLDOWN() --checks if cooldowns where removed correctly
			end
		end
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end)

