--[[
	##AddOn	  : CooldownIcons R(evamped)
	##Subfile : core.lua
	##Author  : Hati-EK
--]]
--##Lib/Ace3 Load
local LCI = LibStub("LibCooldownIcons") -- this is more a personal utility lib (provides some 'extra' functions or extended standard ones)
CooldownIconsR = LibStub("AceAddon-3.0"):NewAddon("CooldownIcons_Revamped","AceConsole-3.0","AceEvent-3.0")
local LIC = LibStub("LibInternalCooldowns-1.0") --LibInternalCooldowns-1.0
local CIR = CooldownIconsR
--Load ButtonFacade Support,SharedMedia Support
local LBF = LibStub("LibButtonFacade", true)
local media = LibStub("LibSharedMedia-3.0")

CIR.Anchor = CreateFrame("Frame","CooldownIconsR_Anchor",UIParent)
CIR.Anchor:SetAllPoints(UIParent)
CIR.ButtonNumber=0

CIR.eventTable={}

--##AddOn Variables
CIR.fade_in_support = true
CIR.gcd = 2
CIR.updateFrequency = 0.5
CIR.lastUpdate = 0
CIR.recompile = false
CIR.curTalentGroup = 1
CIR.Icon_Nil = "Interface\\Icons\\INV_Misc_QuestionMark"
local floor = math.floor 
local tonumber, _G, pairs, unpack, tconcat, wipe, format = tonumber, _G, pairs, unpack, table.concat, wipe, string.format
CIR.ver = GetAddOnMetadata( 'CooldownIcons_Revamped', 'Version') or 'unknown'
if CIR.ver=='rwowi:revision' then CIR.ver='SVN' end
CIR.ver = format( "%s %s(%s)%s", CIR.ver, RED_FONT_COLOR_CODE, 'WotLK', FONT_COLOR_CODE_CLOSE)
--##Frame Table
--not yet important (will be for Groups)
--CIR.frames={}
CIR.icons={}
CIR.timer = {}
--##DB_DEFAULT_ICON
local DB_DEFAULT_ICON = {
	name = nil,
	options = {
		pos = {
			x=0,
			y=0,
		},
		zoom = false,
		grayscaling = false,
		range = false,
		display = 1,
		iconSize = 32,
		font = {
			size = 12,
			style = "Fonts\\FRIZQT__.TTF",
			x=0,
			y=1,
		},
		timeFormat=1,
		tmin_tf4=6,
		rN = "",
		enabled = true,
		group = 1,
		script = "",
		locked = true,
	},
}

--##default_style
default_style = { 'Blizzard', 0, nil }
--##DB_DEFAULT_GROUP
local DB_DEFAULT_GROUP = {"None"}
--##DB_DEFAULT_GROUP_LAYOUT
local DB_DEFAULT_GROUP_LAYOUT = {
	name=nil,
	padding=0,
	icons=12,
	rows=1,
	heirs={},
}


--##command_table
CIR.cmds={
	spell={ --text
		spell_header = {
			name='spell(spellid or spellname)',
			type='header',
			width='full',
			cmdHidden=true,
			order=100,
		},
		spell = {
			type='description',
			cmdHidden=true, order=101,
			name='Adds the given spell (by spellid or spellname) to the CooldownList of this Icon.',
		},
		spell_example = {
			type='description',
			cmdHidden=true, order=102,
			name='Example: spell("Tricks of the Trade") or spell(Tricks of the Trade) will add Tricks of the Trade to the CooldownList of this Icon.',
		},
	},
	item={ --text
		item_header = {
			name='item(spellid or spellname)',
			type='header',
			width='full',
			cmdHidden=true,
			order=100,
		},
		item = {
			type='description',
			cmdHidden=true, order=101,
			name='Adds the given item (by itemid or itemname) to the CooldownList of this Icon.',
		},
		item_example = {
			type='description',
			cmdHidden=true, order=102,
			name='Example: item(Shadowblade Gauntlets) or with quotes will add Shadowblade Gauntlets (i.e. Engineering Enchant) to the CooldownList of this Icon.',
		},
	},
	flag={ --text
		flag_header = {
			name='flag(valid_flags)',
			type='header',
			width='full',
			cmdHidden=true,
			order=100,
		},
		flag = {
			type='description',
			cmdHidden=true, order=101,
			name='Adds the given item(by valid flag commands) to the CooldownList of this Icon.',
		},
		flag_example = {
			type='description',
			cmdHidden=true, order=102,
			name='Example: flag(trinket1) will add your currently first Trinket (upper trinket slot) to the cooldowns of this icon.',
		},
		flag_list = {
			type='description',cmdHidden=true,order=103,
			name=tconcat({"valid flags: ",
				"ammo",
				"head",
				"neck",
				"shoulder",
				"shirt",
				"chest",
				"belt",
				"legs",
				"feet",
				"wrist",
				"gloves",
				"finger1 - upper ringslot",
				"finger2 - lower ringslot",
				"trinket1 - upper trinketslot",
				"trinket2 - lower trinketslot",
				"back",
				"mainhand",
				"offhand",
				"ranged",
				"tabard",
			},"\n"),
		},
	},
	case={ --text
			case_header = {
			name='case(s)',
			type='header',
			width='full',
			cmdHidden=true,
			order=106,
		},
		case = {
			type='description',
			order=107,
			name=tconcat({ --just for easier writing :P
				'stance = the specific stance(i.e. Shadow Dance (Rogue): Number=3, Normal=0, Normal-Stealth=1);\nAlso possible is spelli("Stealth", {0,1}, stance) will enable 0 & 1 as stance \nNOTE: Do not forget { } around it.\nCan be gathered by >/run print(GetShapeshiftForm())',
				'talentgroup = your current talent spec (dual spec) valid number: 1 or 2',
				}, "\n\n"),
		},
	},
	validate={
		"spell",
		"item",
		"flag",
		"stance",
		"talentgroup",
		--"buff",
	},
	valid_flags ={
		equip={
			[0]="ammo",
			[1]="head",
			[2]="neck",
			[3]="shoulder",
			[4]="shirt",
			[5]="chest",
			[6]="belt",
			[7]="legs",
			[8]="feet",
			[9]="wrist",
			[10]="gloves",
			[11]="finger1",
			[12]="finger2",
			[13]="trinket1",
			[14]="trinket2",
			[15]="back",
			[16]="mainhand",
			[17]="offhand",
			[18]="ranged",
			[19]="tabard",
		},
	},
}

CIR.cmds.configtable = {
	spell = {
		name="spell",
		type='group',
		order=100,
		cmdHidden=true,
		args=CIR.cmds.spell,
	},
	item = {
		name="item",
		type='group',
		order=101,
		cmdHidden=true,
		args=CIR.cmds.item,
	},
	flag = {
		name="flag",
		type='group',
		order=102,
		cmdHidden=true,
		args=CIR.cmds.flag,
	},
	case = {
		name="case",
		type='group',
		order=103,
		cmdHidden=true,
		args=CIR.cmds.case,
	},
}


--##Code
function CIR:OnInitialize()
	--define db
	self.db = LibStub("AceDB-3.0"):New("CooldownIconsR_DB", nil, true)
end

function CIR:OnEnable()
	--print loaded information	
	self:Print(CIR.ver.." loaded!")
	--register options table
	LibStub('AceConfig-3.0'):RegisterOptionsTable( 'CooldownIcons_Revamped', self.options)
	--define setup layout
	local ACD = LibStub( 'AceConfigDialog-3.0')
	self.OptionsPanel = ACD:AddToBlizOptions(self.name, "CooldownIcons R", nil, "global_layout")
	self.OptionsPanel.Icons = ACD:AddToBlizOptions(self.name, "Icon Layouts", "CooldownIcons R", "local_layout")
	self.OptionsPanel.Groups = ACD:AddToBlizOptions(self.name, "Icon Groups", "CooldownIcons R", "group_layout")
	self.OptionsPanel.Commands = ACD:AddToBlizOptions(self.name, "Commands", "CooldownIcons R", "commands")
	--slashcommands
	self:RegisterChatCommand("cooldowniconsr", function() self:OpenConfig() end)
	self:RegisterChatCommand("cir", function() self:OpenConfig() end)
	self:RegisterChatCommand("cooldownicons", function() self:OpenConfig() end)
	self:RegisterChatCommand("ci", function() self:OpenConfig() end) 
	
	--LIC.RegisterCallback(self,"InternalCooldowns_Proc")
	
	--Register Custom AceEvent (Option Change)
	self:RegisterMessage("CooldownIconsR_OptionUpdate")
	--Register real Events
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	
	self:ReconstructOptionTable() -- Reconstructs OptionTable, Creates Icons (via Message), Updates OptionTable with new values
	CIR.ButtonNumber=LCI:Getn(CIR.db.char.icondb)	
	if LBF then
		LBF:RegisterSkinCallback( 'CooldownIcons R', self.SkinChanged, self)
	end
	CIR.updateFrequency=(0.5/(10^(self.db.char.accuracy or 0)))
	
	CIR:SPELL_UPDATE_COOLDOWN() --reloadui and so on getting cooldowns
end


function CIR:SkinChanged( SkinID, Gloss, Backdrop, Group, Button, Colors)
	if not CIR.db.char.style then
		CIR.db.char.style = { }
	end
	CIR.db.char.style[1] = SkinID
	CIR.db.char.style[2] = Gloss
	CIR.db.char.style[3] = Backdrop
	CIR.db.char.style[4] = Colors
	for k,v in pairs(CIR.db.char.icondb) do
		local options = v.options
		local mZoom = (LCI:tonumber(options["zoom"])) *.08
		CIR.icons[k].tex:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
	end
end

function CIR:OpenConfig()
	InterfaceOptionsFrame_OpenToCategory(self.OptionsPanel.Commands)
	InterfaceOptionsFrame_OpenToCategory(self.OptionsPanel)
end

--## X = Set & Get-functions
--seperate icon set/get
function CIR:getEnabled(i)
	local k = i[#i-2]
	--self:SendMessage("CooldownIconsR_OptionUpdate", i, v)
	return self.db.char.icondb[k].options.enabled
end
function CIR:setEnabled(i,v)
	local k=i[#i-2]
	self.db.char.icondb[k].options.enabled = v
	self:SendMessage("CooldownIconsR_OptionUpdate", i, v)
	if v or CIR.db.char.config then
		CIR.icons[k]:Show()
	else
		CIR.icons[k]:Hide()
	end
	CIR.icons[k].enabled=v
end
function CIR:getRealName(i)
	local k = i[#i-2]
	return self.db.char.icondb[k].options.rN
end
function CIR:setRealName(i,v)
	local k = i[#i-2]
	self.db.char.icondb[k].options.rN = v
	if CIR.db.char.icondb[k].options.rN~="" and CIR.db.char.icondb[k].options.rN~=nil then
		CIR.options.args.local_layout.args[k].name = v
	else
		CIR.options.args.local_layout.args[k].name = k
	end
end
function CIR:getZoomToggle(i)
	local k = i[#i-2]
	return self.db.char.icondb[k].options.zoom
end
function CIR:setZoomToggle(i,v)
	local k = i[#i-2]
	self.db.char.icondb[k].options.zoom = v
	self:SendMessage("CooldownIconsR_OptionUpdate", i, v)
end
function CIR:getLocked(i)
	local k = i[#i-2]
	return self.db.char.icondb[k].options.locked
end
function CIR:setLocked(i,v)
	local k = i[#i-2]
	self.db.char.icondb[k].options.locked = v
	_, _, _, CIR.db.char.icondb[k].options.pos.x, CIR.db.char.icondb[k].options.pos.y = CIR.icons[k]:GetPoint()
	self:SendMessage("CooldownIconsR_OptionUpdate", i, v)
end
function CIR:getGrayToggle(i)
	local k=i[#i-2]
	return self.db.char.icondb[k].options.grayscaling
end
function CIR:setGrayToggle(i,v)
	local k=i[#i-2]
	CIR.icons[k].grayscaled=v
	self.db.char.icondb[k].options.grayscaling=v
end
function CIR:getGroup(i)
	local k = i[#i-2]
	return self.db.char.icondb[k].options.group
end
function CIR:setGroup(i,v)
	local k=i[#i-2]
	local pre_v = self.db.char.icondb[k].options.group
	self.db.char.icondb[k].options.group=v
	--remove k from old group -> add to new (move to another group)
	local group=CIR.db.char.groups[v]
	if not LCI:inTable(k,CIR.db.char.groupdb[group].heirs) then
		tinsert(CIR.db.char.groupdb[group].heirs,k)
	end
end
function CIR:getTime(i)
	local k=i[#i-2]
	return self.db.char.icondb[k].options.timeFormat
end
function CIR:setTime(i,v)
	local k=i[#i-2]
	self.db.char.icondb[k].options.timeFormat=v
	CIR.icons[k].tf=v
	if v==4 then
		CIR.options.args.local_layout.args[k].args.general.args.tmin_tf4.disabled=false
	else
		CIR.options.args.local_layout.args[k].args.general.args.tmin_tf4.disabled=true
	end
end
function CIR:getRangeToggle(i)
	local k=i[#i-2]
	return self.db.char.icondb[k].options.range
end
function CIR:setRangeToggle(i,v)
	local k=i[#i-2]
	self.db.char.icondb[k].options.range =v
	if not v then
		CIR.icons[k].tex:SetVertexColor(1,1,1,1)
	end
end
function CIR:getTmin_tf4(i)
	local k=i[#i-2]
	if self.db.char.icondb[k].options.timeFormat ==4 then
		i.option.disabled=false
	else
		i.option.disabled=true
	end
	return self.db.char.icondb[k].options.tmin_tf4 or 6
end
function CIR:setTmin_tf4(i,v)
	local k=i[#i-2]
	self.db.char.icondb[k].options.tmin_tf4=v
end
function CIR:getScript(i)
	local k = i[#i-2]
	return self.db.char.icondb[k].options.script
end
function CIR:setScript(i,v)
	local k=i[#i-2]
	self.icons[k].cmd=nil
	self.icons[k].watch=nil
	self.db.char.icondb[k].options.script=v
	self:CompileIcon(k,v)
end
function CIR:getxOffset(i)
	local k = i[#i-2]
	return CIR.db.char.icondb[k].options.pos.x
end
function CIR:setxOffset(i,v)
	local k = i[#i-2]
	CIR.db.char.icondb[k].options.pos.x = v
	CIR.icons[k]:SetPoint("CENTER",CIR.Anchor,"CENTER",v,CIR.db.char.icondb[k].options.pos.y)
end
function CIR:getyOffset(i)
	local k = i[#i-2]
	return CIR.db.char.icondb[k].options.pos.y
end
function CIR:setyOffset(i,v)
	local k = i[#i-2]
	CIR.db.char.icondb[k].options.pos.y = v
	CIR.icons[k]:SetPoint("CENTER",CIR.Anchor,"CENTER",CIR.db.char.icondb[k].options.pos.x,v)
end
function CIR:getIconSize(i)
	local k = i[#i-2]
	return CIR.db.char.icondb[k].options.iconSize
end
function CIR:setIconSize(i,v)
	local k = i[#i-2]
	CIR.db.char.icondb[k].options.iconSize=v
	CIR.icons[k]:SetWidth(v)
	CIR.icons[k]:SetHeight(v)
	if LBF then
		local b = CIR.icons[k]
		LBF:Group('CooldownIcons R'):AddButton( b, {Icon=b.tex})
	end
	local mZoom = (LCI:tonumber(CIR.db.char.icondb[k].options["zoom"])) *.08
	CIR.icons[k].tex:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
	--change possible font offset
	CIR.options.args.local_layout.args[k].args.positionOrSize.args.xFontOffset.min=-(floor(v/2))
	CIR.options.args.local_layout.args[k].args.positionOrSize.args.xFontOffset.max=(floor(v/2))
	CIR.options.args.local_layout.args[k].args.positionOrSize.args.yFontOffset.min=-(floor(v/2)-10)
	CIR.options.args.local_layout.args[k].args.positionOrSize.args.yFontOffset.max=(floor(v/2)+10)
end
function CIR:getFontSize(i)
	local k = i[#i-2]
	return CIR.db.char.icondb[k].options.font.size
end
function CIR:setFontSize(i,v)
	local k = i[#i-2]
	CIR.db.char.icondb[k].options.font.size = v
	CIR.icons[k].time:SetFont(CIR.db.char.icondb[k].options.font.style,v,"OUTLINE")
end
function CIR:getxFontOffset(i)
	local k=i[#i-2]
	return CIR.db.char.icondb[k].options.font.x
end
function CIR:setxFontOffset(i,v)
	local k=i[#i-2]
	CIR.db.char.icondb[k].options.font.x=v
	CIR.icons[k].time:SetPoint("CENTER",CIR.icons[k],"CENTER",v,(CIR.db.char.icondb[k].options.font.y or 1))
end
function CIR:getyFontOffset(i)
	local k=i[#i-2]
	i.option.min = -floor((CIR.db.char.icondb[k].options.iconSize+20)/2)
	i.option.max = floor((CIR.db.char.icondb[k].options.iconSize+20)/2)
	return CIR.db.char.icondb[k].options.font.y or 1
end
function CIR:setyFontOffset(i,v)
	local k=i[#i-2]
	CIR.db.char.icondb[k].options.font.y=v
	CIR.icons[k].time:SetPoint("CENTER",CIR.icons[k],"CENTER",(CIR.db.char.icondb[k].options.font.x or 0),v)
end
--display
function CIR:getDisplayType(i)
	local k =i[#i-2]
	return CIR.db.char.icondb[k].options.display
end
function CIR:setDisplayType(i,v)
	local k =i[#i-2]
	CIR.db.char.icondb[k].options.display=v
	CIR.icons[k].dt=v
	if v==1 then
		CIR.icons[k]:Show()
		CIR.icons[k]:SetAlpha(1)
	elseif v==2 then
		CIR.icons[k]:SetAlpha(0)
	end
end
-- TODO: group set/get
--[[
DEFAULT_Group Functions
function CIR:getGroup_(i)
end
function CIR:setGroup_(i,v)
end


function CIR:getGroup_xOffset(i)
end
function CIR:setGroup_xOffset(i,v)
end
function CIR:getGroup_yOffset(i)
end
function CIR:setGroup_yOffset(i,v)
end
function CIR:getGroup_Rows(i)
end
function CIR:setGroup_Rows(i,v)
end
function CIR:getGroup_Padding(i)
end
function CIR:setGroup_Padding(i,v)
end
function CIR:getGroup_Zoom(i)
end
function CIR:setGroup_Zoom(i,v)
end
function CIR:getGroup_IconSize(i)
end
function CIR:setGroup_IconSize(i,v)
end
function CIR:getGroup_FontSize(i)
end
function CIR:setGroup_FontSize(i,v)
end
]]
--[[
function CIR:getGroup_Zoom(i)
end
function CIR:setGroup_Zoom(i,v)
end
]]


--global set/get
function CIR:getDebug(i)
	return self.db.char.debug
end
function CIR:setDebug(i,v)
	self.db.char.debug = v
end
function CIR:getConfig(i)
	return self.db.char.config
end
function CIR:setConfig(i, v)
	self.db.char.config=v
	for icon,lines in pairs(CIR.comp) do
		--print("Compile "..icon.." : "..tostring(lines))
		CIR:CompileLines(lines,icon)
	end
end
function CIR:getAccuracy(i)
	return (CIR.db.char.accuracy or 0)
end
function CIR:setAccuracy(i,v)
	CIR.db.char.accuracy=v
	CIR.updateFrequency=(0.5/(10^v))
end
function CIR:getTextColor(i)
	return unpack(CIR.db.char.textcolor or {1.0,1.0,1.0,1.0})
end
function CIR:setTextColor(i,r,g,b,a)
	CIR.db.char.textcolor={r,g,b,a}
	--update all icons
	for icon,iT in pairs(CIR.icons) do
		iT.time:SetTextColor(r,g,b,a)
	end
end
function CIR:getFontStyle(i)
	local _,defaulti = LCI:inTable("Friz Quadrata TT",media:List('font'))
	return CIR.db.char.fontstyle or defaulti
end
function CIR:setFontStyle(i,v)
	CIR.db.char.fontstyle=v
	local nF = media:List('font')[v]
	local nF_Dir = media:Fetch("font",nF)
	for icon,iT in pairs(CIR.icons) do
		local newFontOpt = self.db.char.icondb[icon].options.font
		iT.time:SetFont(nF_Dir,newFontOpt.size,"OUTLINE")
		newFontOpt.style=nF_Dir
	end
end

--OptionsTable
CIR.options = {
	type='group',
	name="CooldownIcons R(evamped)",
	handler = CIR,
	args = {
		global_layout={
			type = 'group',
			name = "CooldownIcons R(evamped) - Global Settings",
			order = 1,
			args={
				reversion = { type='description', name=CIR.ver, order=1, cmdHidden=true,},
				description = { type='description', name="Tracks and Displays your choosen Cooldowns in a smart way.", order=2, cmdHidden=true,},
				debug = {
					type='toggle', name='Toggle Debug',order=103,
					desc='Enables/Disables Debug Msgs',
					width='full',
					set="setDebug",
					get="getDebug",
				},
				config={
					type='toggle', name='Toggle Config',order=102,
					desc='Enable/Disable Config-Mode (Display of hidden Icons and Group Frames)',
					width='full',
					set='setConfig',
					get='getConfig',
				},
				accuracy={
					type='range', name='Amount of fractional digits',order=-1,
					desc='Enables fractional digits to keep track of real Cooldowns (ex. Chain Lightning 3.5 cooldown - without it would be rounded to 3)\n0=disable, 1=1 digit after comma(,)\nCurrently only enabled if used Timeformat: 1,3 and 4\nNote: This will also lower/higher the updateFrequency.',
					min=0,max=2,
					step=1,
					get='getAccuracy',
					set='setAccuracy',
				},
				textcolor={
					type='color', name='Cooldown Text Color',order=100,
					desc='Changes the color of the Cooldown Text displayed on Icon.',
					hasAlpha=false,
					get='getTextColor',
					set='setTextColor',
				},
				font_style={
					type='select',name='Font Style: ',order=104,
					values=media:List('font'), style='dropdown',
					get="getFontStyle",
					set="setFontStyle",
				},
			},
		},
		local_layout={
			type='group',
			name='CooldownIcons R(evamped) - Icon Settings',
			order=2,
			args={},
		},
		group_layout={
			type='group',
			name='CooldownIcons R(evamped) - Group Settings',
			order=3,
			args={}
		},
		commands={ 
			type='group',
			name='CooldownIcons R(evamped) - Commands',
			order=4,
			args=CIR.cmds.configtable,
		},
	},
}
--finishing optionTable
do
	--##Icon Management
	do
		function CIR:__ICT()
			return {
				general = {
					name='General',
					type='group',
					args = {
						enabled = {
							type='toggle', name='Enable Icon',order=100,
							desc='Enables/Disables the current Icon',
							set="setEnabled",
							get="getEnabled",
						},
						locked = {
							type='toggle', name="Toggle Lock status",order=101,
							desc='Locks/Unlocks the current Icon',
							get="getLocked",
							set="setLocked",
						},
						rN = {
							type='input', name="Name",order=0,
							width='full',
							get="getRealName",
							set="setRealName",
						},
						zoom = {
							type='toggle', name='Toggle Zoom',order=103,
							desc='Enables/Disables zoomed Icontexture',
							get="getZoomToggle",
							set="setZoomToggle",
						},
						grayscaling = {
							type='toggle', name='Toggle Grayscaling',order=104,
							desc='Enables/Disables grayscaling of the Icon Texture on Cooldown.',
							get="getGrayToggle",
							set="setGrayToggle",
						},
						displayType= {
							type='select', name='Display type: ',order=105,
							values={ "Show Always", "On Cooldown only", "If ready" },
							get='getDisplayType',
							set='setDisplayType',
						},
						timeFormat = {
							type='select', name='Time format: ',order=106,
							values={ "Seconds,"..format("%."..(self.db.char.accuracy or 0).."f","81"),"Minute:Seconds,1:21","Minutes, 2m","Milliseconds if t<tmin,5.9s"}, style='dropdown',
							get="getTime",
							set="setTime",
						},
						range = {
							type='toggle', name='Toggle Range',order=107,
							desc='Enables/Disables Range-Check',
							get="getRangeToggle",
							set="setRangeToggle",
						},
						tmin_tf4 = {
							type='range', name='Minimum duration for decimal precision',order=108,
							desc='',
							min=1,max=10,
							step=1,
							get='getTmin_tf4',
							set='setTmin_tf4',
						},
						script = {
							type='input', name="Script/Functions: ",order=109,
							width='full', multiline=5,
							get="getScript",
							set="setScript",
						},
					},
				},
				positionOrSize={
					name='Positioning',
					type='group',
					args = {
						xOffset={
							type='range', name='x-Offset from the middle of the screen',order=109,
							desc='',
							min=-floor(UIParent:GetWidth()/2),max=floor(UIParent:GetWidth()/2),
							step=1,
							get='getxOffset',
							set='setxOffset',					
						},
						yOffset={
							type='range', name='y-Offset from the middle of the screen',order=110,
							desc='',
							min=-floor(UIParent:GetHeight()/2),max=floor(UIParent:GetHeight()/2),
							step=1,
							get='getyOffset',
							set='setyOffset',					
						},
						iconSize={
							type='range', name='Icon size',order=111,
							desc='Changes the dimensions of the icon (they are still squares)',
							min=12,max=144,width='full',
							step=1,
							get='getIconSize',
							set='setIconSize',
						},
						fontSize={
							type='range', name='Font size',order=112,
							desc='Changes the size of the font (they are still squares)',
							min=1,max=32,width='full',
							step=1,
							get='getFontSize',
							set='setFontSize',
						},
						xFontOffset={
							type='range', name='x-Offset of the Cooldown Text on the current Icon',order=113,
							desc='Changes the x-position the CooldownText is shown \'near\' the Icon.',
							min=-floor(32/2),max=floor(32/2),width='full',
							step=1,
							get='getxFontOffset',
							set='setxFontOffset',
						},
						yFontOffset={
							type='range', name='y-Offset of the Cooldown Text on the current Icon',order=114,
							desc='Changes the y-position the CooldownText is shown \'near\' the Icon.',
							min=-floor(52/2),max=floor(52/2),width='full',
							step=1,
							get='getyFontOffset',
							set='setyFontOffset',
						},
						group = {
							type='select', name='Align to Group: ',order=115,
							values=CIR.db.char.groups or DB_DEFAULT_GROUP, style='dropdown',
							get="getGroup",
							set="setGroup",
						},
					},
				}
			}
		end
	end
	--## BTN = addNewBtn_Func()
	local function addNewBtn_Func(info)
		--init value
		if not(type(CIR.db.char.icondb)=='table') then
			CIR.db.char.icondb={}
		end
		CIR.ButtonNumber = LCI:Getn(CIR.db.char.icondb)
		local newIcon = "Icon"..CIR.ButtonNumber
		local configargs = CIR:__ICT()
		local t_config = {
			name=newIcon,
			type='group',
			cmdHidden=true,
			childGroups='tab',
			args=configargs,
		}
		local t_storeable = {}
		t_storeable = LCI:deepcopy(DB_DEFAULT_ICON)
		t_storeable.name = newIcon
		if CIR.db.char.icondb["Icon"..CIR.ButtonNumber-1] then
			local preIcon_Font = CIR.db.char.icondb["Icon"..CIR.ButtonNumber-1].options.font.style
			t_storeable.options.font.style = preIcon_Font or "Fonts\\FRIZQT__.TTF"
		end
		--create in OptionTable
		CIR.options.args.local_layout.args[newIcon]=t_config
		--SV update
		CIR.db.char.icondb[newIcon] = t_storeable
		CIR:SendMessage("CooldownIconsR_OptionUpdate",newIcon, t_storeable)
	end
	CIR.options.args.local_layout.args={
		addNewBtn={
			type='execute',
			name="Add new Icon",
			desc="Adds a new customizeable Icon for a new Cooldown to be tracked.",
			func=addNewBtn_Func,
			order=-1,
		},
		-- TODO: finishing delete function
		remActBtn={ --remove actual chosen button
			type='execute',
			name="[NYI]Remove current Icon",
			desc="[NYI]Removes the currently marked icon",
			func=function(info) table.foreach(info.option,print) end,
		},
	}
	-- TODO: Group Managment
	--##Group Management
	--CIR:__GroupConfigTable
	--[[
	do
		function CIR:__GCT()
			return {
				zoom={
					type='toggle', name='Enable Zoom',order=100,
					desc='Toggle zoom status for all icons aligned to this group.',
					set="setGroup_Zoom",
					get="getGroup_Zoom",
				},
			}
		end
	end
	--addGroupBtn_Func
	local function addGroupBtn_Func(info)
		if not(type(CIR.db.char.groupdb)=='table') then
			CIR.db.char.groupdb={}
		end
		local newGroup="Icon"..LCI:Getn(CIR.db.char.groupdb)
		local t_config = {
			name=newGroup,
			type='group'
			cmdHidden=true,
			args=CIR:__GCT(),
		}
		local t_storeable = DB_DEFAULT_GROUP_LAYOUT
		t_storeable.name=newGroup
		
		CIR.options.args.local_layout.args[newGroup]=t_config
		
		CIR.db.char.groupdb[newGroup] = t_storeable
		
	end
	--addNewGroupBtn
	CIR.options.args.group_layout.args={
		addGroupBtn={
			type='execute'
			name='Add new Group'
			desc='Adds a new Group to sort buttons to.'
			func=addGroupBtn_Func,
			order=-1,
		},
	},
	]]
end

--##Update Actual Button
function CIR:CooldownIconsR_OptionUpdate(event, i, v)
	if (type(i)=='table' and (type(v)=='boolean' or type(v)=='string') ) then --called from OptionTable
		local k = i[#i-2] --icon_Name
		local j = i[#i]
		if j=="enabled" then
			CIR:DEBUG(tostring(k).."."..j.." changed to "..tostring(v or CIR.db.char.icondb[k].options[j]))
		elseif j=="zoom" then
			local mZoom = (LCI:tonumber(v))*.08
			CIR.icons[k].tex:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
			CIR:DEBUG(tostring(k).."."..j.." changed to "..tostring(v or CIR.db.char.icondb[k].options[j]))
		elseif j=="locked" then
			CIR:DEBUG(tostring(k).."."..j.." changed to "..tostring(v or CIR.db.char.icondb[k].options[j]))
			if v then
				_, _, _, CIR.db.char.icondb[k].options.pos.x, CIR.db.char.icondb[k].options.pos.y = CIR.icons[k]:GetPoint()
				CIR.icons[k]:SetMovable(false)
				CIR.icons[k]:EnableMouse(false)
				CIR.icons[k]:SetScript("OnMouseDown",nil)
				CIR.icons[k]:SetScript("OnMouseUp",nil)
			else
				CIR.icons[k]:SetMovable(true)
				CIR.icons[k]:EnableMouse(true)
				CIR.icons[k]:SetScript("OnMouseDown",function()
					CIR.iconmovement={}	
					CIR.iconmovement.frame={}
					CIR.iconmovement.screen={}
					CIR.iconmovement.after={}						
					_,_,_,CIR.iconmovement.frame.x, CIR.iconmovement.frame.y = CIR.icons[k]:GetPoint()
					CIR.icons[k]:StartMoving()
					_,_,_,CIR.iconmovement.screen.x,CIR.iconmovement.screen.y = CIR.icons[k]:GetPoint()
				end)
				CIR.icons[k]:SetScript("OnMouseUp",function()
					_,_,_,CIR.iconmovement.after.x, CIR.iconmovement.after.y = CIR.icons[k]:GetPoint()
					CIR.icons[k]:StopMovingOrSizing()
					local delta={}
					delta.x = CIR.iconmovement.after.x - CIR.iconmovement.screen.x --calc offset x
					delta.y = CIR.iconmovement.after.y - CIR.iconmovement.screen.y --calc offset y
					local x = CIR.iconmovement.frame.x+delta.x
					local y = CIR.iconmovement.frame.y+delta.y
					CIR:DEBUG(x.." : "..y)
					CIR.icons[k]:SetPoint("CENTER",CIR.Anchor,"CENTER",x,y)
					CIR.db.char.icondb[k].options.pos.x = x
					CIR.db.char.icondb[k].options.pos.y = y
					wipe(CIR.iconmovement)
				end)
			end
		end
	elseif (type(i)=='string' and type(v)=='table') then --called from reconstruct
		--CIR:DEBUG(tostring(i).." : "..tostring(v))
		local options = v.options
		CIR.icons[i] = {}
		CIR.icons[i].tex = {}
		CIR.icons[i].time = { }
		CIR.icons[i] = CreateFrame("Button", "CIR_"..i, CIR.Anchor)
		CIR.icons[i]:SetHeight(options["iconSize"])
		CIR.icons[i]:SetWidth(options["iconSize"])
		CIR.icons[i]:SetClampedToScreen(true)
		CIR.icons[i]:SetPoint("CENTER",CIR.Anchor,"CENTER",options.pos.x,options.pos.y)
		CIR.icons[i]:SetFrameStrata( 'LOW')
		CIR.icons[i].tex = CIR.icons[i]:CreateTexture(CIR.icons[i]:GetName().."_Texture")
		CIR.icons[i].tex:SetAllPoints(CIR.icons[i])
		CIR.icons[i].tex:SetTexture(CIR.Icon_Nil)
		CIR.icons[i].time = CIR.icons[i]:CreateFontString(CIR.icons[i]:GetName().."_Time","ARTWORK")
		CIR.icons[i].time:SetPoint("CENTER",CIR.icons[i],"CENTER",options.font.x,options.font.y)
		CIR.icons[i].time:SetFont((options["font"]["style"] or "Fonts\\FRIZQT__.TTF"),options["font"]["size"],"OUTLINE")
		CIR.icons[i].time:SetTextColor(unpack(CIR.db.char.textcolor or {1.0,1.0,1.0,1.0}))
		if options["locked"] then
			CIR.icons[i]:SetMovable(false)
			CIR.icons[i]:EnableMouse(false)
			CIR.icons[i]:SetScript("OnMouseDown",nil)
			CIR.icons[i]:SetScript("OnMouseUp",nil)
		else
			CIR.icons[i]:SetMovable(true)
			CIR.icons[i]:EnableMouse(true)
			CIR.icons[i]:SetScript("OnMouseDown",function()
					CIR.iconmovement={}
					CIR.iconmovement.frame={}
					CIR.iconmovement.screen={}
					CIR.iconmovement.after={}
					_,_,_,CIR.iconmovement.frame.x, CIR.iconmovement.frame.y = CIR.icons[i]:GetPoint()
					CIR.icons[i]:StartMoving()
					_,_,_,CIR.iconmovement.screen.x,CIR.iconmovement.screen.y = CIR.icons[i]:GetPoint()
				end)
			CIR.icons[i]:SetScript("OnMouseUp",function()
					_,_,_,CIR.iconmovement.after.x, CIR.iconmovement.after.y = CIR.icons[i]:GetPoint()
					CIR.icons[i]:StopMovingOrSizing()
					local delta={}
					delta.x = CIR.iconmovement.after.x - CIR.iconmovement.screen.x --calc offset x
					delta.y = CIR.iconmovement.after.y - CIR.iconmovement.screen.y --calc offset y
					local x = CIR.iconmovement.frame.x+delta.x
					local y = CIR.iconmovement.frame.y+delta.y
					CIR:DEBUG(x.." : "..y)
					CIR.icons[i]:SetPoint("CENTER",CIR.Anchor,"CENTER",x,y)
					CIR.db.char.icondb[i].options.pos.x = x
					CIR.db.char.icondb[i].options.pos.y = y
					wipe(CIR.iconmovement)
			end)
		end
		if LBF then
			CIR:DEBUG( tostring(CIR.icons[i]))
			local b = CIR.icons[i]
			LBF:Group('CooldownIcons R'):AddButton( b, {Icon=b.tex})
		end
		local mZoom = (LCI:tonumber(options["zoom"])) *.08
		CIR.icons[i].tex:SetTexCoord(0.0+mZoom, 1.0-mZoom, 0.0+mZoom, 1.0-mZoom)
		self:CompileIcon(i,options.script)
		CIR.icons[i].enabled = options.enabled
		if (not options.enabled and not CIR.db.char.config) then
			CIR.icons[i]:Hide()
		elseif (options.enabled and options.display==2) then
			CIR.icons[i]:SetAlpha(0)
		end
		CIR.icons[i].realname=i
	end
end


function CIR:ReconstructOptionTable()
	--##UpdateTables
	if not(type(CIR.db.char.icondb)=='table') then
		CIR.db.char.icondb={}
	end
	for k,v in pairs(DB_DEFAULT_ICON.options) do
		for i,o in pairs(CIR.db.char.icondb) do
			if (type(o)=='table') then
				if (o[v]~=nil and type(v)=='table') then --check for subtables/values
					local n = 0
					for p,q in pairs(o[v]) do
						n=n+1
					end
					if n>0 then
						CIR.db.char.icondb[i].options[v]=DB_DEFAULT_ICON.options[v]
					end
				elseif (o[v]==nil) then
					CIR.db.char.icondb[i].options[v]=DB_DEFAULT_ICON.options[v]
				end
			end
		end
	end
	if not(type(CIR.db.char.groupdb)=='table') then
		CIR.db.char.groupdb={}
	end
	
	if LBF then
		LBF:Group('CooldownIcons R'):Skin( unpack(CIR.db.char.style or default_style))
	end
	--##Icons
	CIR.id = CIR.db.char.id or 0
	if (type(CIR.db.char.icondb)=='table') then
		for k,v in pairs(CIR.db.char.icondb) do
			if k~="id" and type(v)=='table' then
				--Create OptionsTable
				CIR.options.args.local_layout.args[k] = {
					name=function()
						if CIR.db.char.icondb[k].options.rN~="" and CIR.db.char.icondb[k].options.rN~=nil then
								return CIR.db.char.icondb[k].options.rN
							else
								return k
							end
						end,
						type='group',
						cmdHidden=true,
						childGroups = "tab",
						args=CIR:__ICT() --add IconConfigTable 
					}
					self:SendMessage("CooldownIconsR_OptionUpdate", k, v)
			else
			end
			--[[Update SV Table
			for i,j in pairs(DB_DEFAULT_ICON.options) do
				CIR:DEBUG(tostring(i).." : "..tostring(j))
			end]]
		end
	end
end

function CIR:DEBUG(...)
	if CIR.db.char.debug then
		self:Print("[Debug]",...)
	end
end

function CIR:OnDisable()
end


--##Flag Handler
function CIR:FlagToEquip(flag)
	local v=flag -- could also be a spellname/id as of LCI:GetCooldownByCmd
	local inTable,num = LCI:inTable(flag,CIR.cmds.valid_flags.equip)
	if inTable then
		v=num
	end
	return v --returns invID or spellid/name, itemname/id
end


function CIR:UNIT_INVENTORY_CHANGED(...)
	if arg1=='player' then
		for icon,iT in pairs(CIR.icons) do
			if iT.cmd=='flag' then
				CIR.icons[icon].tex:SetTexture(CIR:SetTextureByCmd(iT.cmd,iT.watch) or CIR.Icon_Nil)
			end
		end
	end
end

function CIR:ACTIVE_TALENT_GROUP_CHANGED(...)
	--print(event)
	if not CIR.eventTable[event] then return end
	CIR:DEBUG(event)
	--disable rangecheck for recompile (prevents range-check errors)
	CIR.recompile=true
	for i,v in ipairs(CIR.eventTable[event]) do
		local lines=CIR.comp[v]
		CIR:CompileLines(lines,v)
	end
	--reanble rangecheck
	CIR.recompile=false
end

function CIR:UPDATE_SHAPESHIFT_FORM(...)
	--print(event)
	if not CIR.eventTable[event] then return end
	--ISSUE: lowering Compiles per Shapeshift to 1 (seems like this event is called very often if you swap)
	CIR:DEBUG(event)
	for i,v in ipairs(CIR.eventTable[event]) do
		local lines=CIR.comp[v]
		CIR:CompileLines(lines,v)
	end
	CIR:SPELL_UPDATE_COOLDOWN() --regenerate cooldowns
end



